/[gentoo-x86]/eclass/qt4-build.eclass
Gentoo

Diff of /eclass/qt4-build.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.96 Revision 1.159
1# Copyright 1999-2011 Gentoo Foundation 1# Copyright 1999-2015 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.96 2011/10/30 14:21:14 hwoarang Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.159 2015/03/06 14:08:07 dlan Exp $
4 4
5# @ECLASS: qt4-build.eclass 5# @ECLASS: qt4-build.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# Ben de Groot <yngwin@gentoo.org>, 7# Qt herd <qt@gentoo.org>
8# Markos Chandras <hwoarang@gentoo.org>,
9# Caleb Tennis <caleb@gentoo.org>
10# Alex Alexander <wired@gentoo.org>
11# @BLURB: Eclass for Qt4 split ebuilds. 8# @BLURB: Eclass for Qt4 split ebuilds.
12# @DESCRIPTION: 9# @DESCRIPTION:
13# This eclass contains various functions that are used when building Qt4 10# This eclass contains various functions that are used when building Qt4.
14 11
15inherit base eutils multilib toolchain-funcs flag-o-matic versionator 12case ${EAPI} in
13 4|5) : ;;
14 *) die "qt4-build.eclass: unsupported EAPI=${EAPI:-0}" ;;
15esac
16 16
17MY_PV=${PV/_/-} 17inherit eutils flag-o-matic multilib toolchain-funcs
18if version_is_at_least 4.5.99999999; then 18
19HOMEPAGE="https://www.qt.io/ https://qt-project.org/"
20LICENSE="|| ( LGPL-2.1 GPL-3 )"
21SLOT="4"
22
23case ${PV} in
24 4.?.9999)
25 QT4_BUILD_TYPE="live"
26 EGIT_REPO_URI=(
27 "git://gitorious.org/qt/qt.git"
28 "https://git.gitorious.org/qt/qt.git"
29 )
30 EGIT_BRANCH=${PV%.9999}
31 inherit git-r3
32 ;;
33 *)
34 QT4_BUILD_TYPE="release"
19 MY_P=qt-everywhere-opensource-src-${MY_PV} 35 MY_P=qt-everywhere-opensource-src-${PV/_/-}
20 [[ ${CATEGORY}/${PN} != x11-libs/qt-xmlpatterns ]] && 36 SRC_URI="http://download.qt.io/archive/qt/${PV%.*}/${PV}/${MY_P}.tar.gz"
21 [[ ${CATEGORY}/${PN} != x11-themes/qgtkstyle ]] && 37 S=${WORKDIR}/${MY_P}
22 IUSE="+exceptions" 38 ;;
23else 39esac
24 MY_P=qt-x11-opensource-src-${MY_PV} 40
41IUSE="aqua debug pch"
42[[ ${PN} != qtxmlpatterns ]] && IUSE+=" +exceptions"
43
44DEPEND="virtual/pkgconfig"
45if [[ ${QT4_BUILD_TYPE} == live ]]; then
46 DEPEND+=" dev-lang/perl"
25fi 47fi
26 48
27if version_is_at_least 4.7.99999999; then
28 IUSE+=" c++0x qpa"
29fi
30
31HOMEPAGE="http://qt.nokia.com/"
32SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz"
33
34LICENSE="|| ( LGPL-2.1 GPL-3 )"
35IUSE+=" debug pch aqua"
36
37RDEPEND="
38 !<x11-libs/qt-assistant-${PV}
39 !>x11-libs/qt-assistant-${PV}-r9999
40 !<x11-libs/qt-core-${PV}
41 !>x11-libs/qt-core-${PV}-r9999
42 !<x11-libs/qt-dbus-${PV}
43 !>x11-libs/qt-dbus-${PV}-r9999
44 !<x11-libs/qt-demo-${PV}
45 !>x11-libs/qt-demo-${PV}-r9999
46 !<x11-libs/qt-gui-${PV}
47 !>x11-libs/qt-gui-${PV}-r9999
48 !<x11-libs/qt-multimedia-${PV}
49 !>x11-libs/qt-multimedia-${PV}-r9999
50 !<x11-libs/qt-opengl-${PV}
51 !>x11-libs/qt-opengl-${PV}-r9999
52 !<x11-libs/qt-phonon-${PV}
53 !>x11-libs/qt-phonon-${PV}-r9999
54 !<x11-libs/qt-qt3support-${PV}
55 !>x11-libs/qt-qt3support-${PV}-r9999
56 !<x11-libs/qt-script-${PV}
57 !>x11-libs/qt-script-${PV}-r9999
58 !<x11-libs/qt-sql-${PV}
59 !>x11-libs/qt-sql-${PV}-r9999
60 !<x11-libs/qt-svg-${PV}
61 !>x11-libs/qt-svg-${PV}-r9999
62 !<x11-libs/qt-test-${PV}
63 !>x11-libs/qt-test-${PV}-r9999
64 !<x11-libs/qt-webkit-${PV}
65 !>x11-libs/qt-webkit-${PV}-r9999
66 !<x11-libs/qt-xmlpatterns-${PV}
67 !>x11-libs/qt-xmlpatterns-${PV}-r9999
68"
69
70S=${WORKDIR}/${MY_P}
71
72# @FUNCTION: qt4-build_pkg_setup 49# @FUNCTION: qt4-build_pkg_setup
73# @DESCRIPTION: 50# @DESCRIPTION:
74# Sets up S, MY_P, PATH, and LD_LIBRARY_PATH 51# Sets up PATH and LD_LIBRARY_PATH.
75qt4-build_pkg_setup() { 52qt4-build_pkg_setup() {
76 [[ ${EAPI} == 2 ]] && use !prefix && EPREFIX= 53 # Warn users of possible breakage when downgrading to a previous release.
77
78 # Protect users by not allowing downgrades between releases
79 # Downgrading revisions within the same release should be allowed 54 # Downgrading revisions within the same release is safe.
80 if has_version '>'${CATEGORY}/${P}-r9999 ; then 55 if has_version ">${CATEGORY}/${P}-r9999:4"; then
81 if [[ -z $I_KNOW_WHAT_I_AM_DOING ]] ; then 56 ewarn
82 eerror "Sanity check to keep you from breaking your system:"
83 eerror " Downgrading Qt is completely unsupported and will break your system!"
84 die "aborting to save your system"
85 else
86 ewarn "Downgrading Qt is completely unsupported and will break your system!" 57 ewarn "Downgrading Qt is completely unsupported and can break your system!"
87 fi 58 ewarn
88 fi
89
90 if [[ "${PN}" == "qt-webkit" ]]; then
91 eshopts_push -s extglob
92 if is-flagq '-g?(gdb)?([1-9])'; then
93 echo
94 ewarn "You have enabled debug info (probably have -g or -ggdb in your \$C{,XX}FLAGS)."
95 ewarn "You may experience really long compilation times and/or increased memory usage."
96 ewarn "If compilation fails, please try removing -g{,gdb} before reporting a bug."
97 ewarn "For more info check out bug #307861"
98 echo
99 fi
100 eshopts_pop
101 fi 59 fi
102 60
103 PATH="${S}/bin${PATH:+:}${PATH}" 61 PATH="${S}/bin${PATH:+:}${PATH}"
104 if [[ ${CHOST} != *-darwin* ]]; then 62 if [[ ${CHOST} != *-darwin* ]]; then
105 LD_LIBRARY_PATH="${S}/lib${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}" 63 LD_LIBRARY_PATH="${S}/lib${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}"
110 # avoid extract failure. 68 # avoid extract failure.
111 [[ ${CHOST} == *-apple-darwin* ]] && \ 69 [[ ${CHOST} == *-apple-darwin* ]] && \
112 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm 70 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm
113 ${QT4_EXTRACT_DIRECTORIES}" 71 ${QT4_EXTRACT_DIRECTORIES}"
114 fi 72 fi
115
116 # Make sure ebuilds use the required EAPI
117 if [[ ${EAPI} != [23] ]]; then
118 eerror "The qt4-build eclass requires EAPI=2 or EAPI=3, but this ebuild is using"
119 eerror "EAPI=${EAPI:-0}. The ebuild author or editor failed. This ebuild needs to be"
120 eerror "fixed. Using qt4-build eclass without EAPI=2 or EAPI=3 will fail."
121 die "qt4-build eclass requires EAPI=2 or EAPI=3"
122 fi
123
124 if ! version_is_at_least 4.1 $(gcc-version); then
125 ewarn "Using a GCC version lower than 4.1 is not supported!"
126 fi
127} 73}
74
75# @ECLASS-VARIABLE: PATCHES
76# @DEFAULT_UNSET
77# @DESCRIPTION:
78# Array variable containing all the patches to be applied. This variable
79# is expected to be defined in the global scope of ebuilds. Make sure to
80# specify the full path. This variable is used in src_prepare phase.
81#
82# Example:
83# @CODE
84# PATCHES=(
85# "${FILESDIR}/mypatch.patch"
86# "${FILESDIR}/patches_folder/"
87# )
88# @CODE
89
90# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES
91# @DEFAULT_UNSET
92# @DESCRIPTION:
93# Space-separated list of directories that will be extracted
94# from Qt tarball.
128 95
129# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES 96# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES
97# @DEFAULT_UNSET
130# @DESCRIPTION: 98# @DESCRIPTION:
131# Arguments for build_target_directories. Takes the directories, in which the 99# Space-separated list of directories that will be configured,
132# code should be compiled. This is a space-separated list 100# compiled, and installed. All paths must be relative to ${S}.
133
134# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES
135# @DESCRIPTION:
136# Space separated list including the directories that will be extracted from Qt
137# tarball
138 101
139# @FUNCTION: qt4-build_src_unpack 102# @FUNCTION: qt4-build_src_unpack
140# @DESCRIPTION: 103# @DESCRIPTION:
141# Unpacks the sources 104# Unpacks the sources.
142qt4-build_src_unpack() { 105qt4-build_src_unpack() {
143 setqtenv 106 setqtenv
144 local unpack_p="${MY_P}" 107
145 case "${PV}" in 108 if [[ $(gcc-major-version) -lt 4 ]] || [[ $(gcc-major-version) -eq 4 && $(gcc-minor-version) -lt 4 ]]; then
146 4.8.0_*) 109 ewarn
147 unpack_p="qt-everywhere-opensource-src-${PV/_*}" 110 ewarn "Using a GCC version lower than 4.4 is not supported."
111 ewarn
112 fi
113
114 if [[ ${PN} == qtwebkit ]]; then
115 eshopts_push -s extglob
116 if is-flagq '-g?(gdb)?([1-9])'; then
117 ewarn
118 ewarn "You have enabled debug info (probably have -g or -ggdb in your CFLAGS/CXXFLAGS)."
119 ewarn "You may experience really long compilation times and/or increased memory usage."
120 ewarn "If compilation fails, please try removing -g/-ggdb before reporting a bug."
121 ewarn "For more info check out https://bugs.gentoo.org/307861"
122 ewarn
123 fi
124 eshopts_pop
125 fi
126
127 case ${QT4_BUILD_TYPE} in
128 live)
129 git-r3_src_unpack
148 ;; 130 ;;
131 release)
132 local tarball="${MY_P}.tar.gz" target= targets=
133 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \
134 src/{qbase,qt_targets,qt_install}.pri bin config.tests \
135 mkspecs qmake ${QT4_EXTRACT_DIRECTORIES}
136 do
137 targets+="${MY_P}/${target} "
138 done
139
140 ebegin "Unpacking parts of ${tarball}:" ${targets//${MY_P}\/}
141 tar -xzf "${DISTDIR}/${tarball}" ${targets}
142 eend $? || die "failed to unpack"
143 ;;
149 esac 144 esac
150 local target targets=
151 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \
152 src/{qbase,qt_targets,qt_install}.pri bin config.tests mkspecs qmake \
153 ${QT4_EXTRACT_DIRECTORIES}; do
154 targets+=" ${unpack_p}/${target}"
155 done
156
157 echo tar xzf "${DISTDIR}"/${MY_P}.tar.gz ${targets}
158 tar xzf "${DISTDIR}"/${MY_P}.tar.gz ${targets} || die
159 case "${PV}" in
160 4.8.0_*)
161 mv ${WORKDIR}/qt-everywhere-opensource-src-${PV/_*} \
162 ${WORKDIR}/qt-everywhere-opensource-src-${MY_PV}
163 ;;
164 esac
165} 145}
166
167# @ECLASS-VARIABLE: PATCHES
168# @DESCRIPTION:
169# In case you have patches to apply, specify them in PATCHES variable. Make sure
170# to specify the full path. This variable is necessary for src_prepare phase.
171# example:
172# PATCHES="${FILESDIR}"/mypatch.patch
173# ${FILESDIR}"/mypatch2.patch"
174#
175 146
176# @FUNCTION: qt4-build_src_prepare 147# @FUNCTION: qt4-build_src_prepare
177# @DESCRIPTION: 148# @DESCRIPTION:
178# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix 149# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix
179# source files in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified on /etc/make.conf. 150# the build system in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified in make.conf.
180qt4-build_src_prepare() { 151qt4-build_src_prepare() {
181 setqtenv 152 setqtenv
182 cd "${S}"
183 153
184 # fix qt 4.7 regression that skips -fvisibility=hidden 154 if [[ ${QT4_BUILD_TYPE} == live ]]; then
185 if version_is_at_least "4.7.0_beta1"; then 155 QTDIR="." ./bin/syncqt || die "syncqt failed"
186 sed -e "s/^gcc|g++)/*gcc|*g++)/" \
187 -i config.tests/unix/fvisibility.test ||
188 die "visibility fixing sed failed"
189 fi 156 fi
157
190 # fix libx11 dependency on non X packages 158 # avoid X11 dependency in non-gui packages
191 if version_is_at_least "4.7.0_beta2"; then
192 local NOLIBX11PKG="qt-core qt-dbus qt-script qt-sql qt-test qt-xmlpatterns" 159 local nolibx11_pkgs="qtbearer qtcore qtdbus qtscript qtsql qttest qtxmlpatterns"
193 has ${PN} ${NOLIBX11PKG} && qt_nolibx11 160 has ${PN} ${nolibx11_pkgs} && qt_nolibx11
194 [[ ${PN} == "qt-assistant" ]] && qt_assistant_cleanup
195 fi
196 161
197 if use aqua; then 162 if use aqua; then
198 # provide a proper macx-g++-64 163 # provide a proper macx-g++-64
199 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir) 164 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir)
200 165
201 sed -e '/^CONFIG/s:app_bundle::' \ 166 sed -e '/^CONFIG/s:app_bundle::' \
202 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \ 167 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \
203 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed failed" 168 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
204 fi 169 fi
205 170
206 if [[ ${PN} != qt-core ]]; then 171 if [[ ${CATEGORY}/${PN} != dev-qt/qtcore ]]; then
207 skip_qmake_build_patch 172 skip_qmake_build
208 skip_project_generation_patch 173 skip_project_generation
209 symlink_binaries_to_buildtree 174 symlink_binaries_to_buildtree
210 fi 175 fi
211 176
212 if [[ ${CHOST} == *86*-apple-darwin* ]] ; then 177 if use_if_iuse c++0x; then
213 # qmake bus errors with -O2 but -O3 works
214 replace-flags -O2 -O3
215 fi
216
217 # Bug 178652
218 if [[ $(gcc-major-version) == 3 ]] && use amd64; then
219 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS"
220 append-flags -fno-gcse
221 fi
222
223 if has c++0x ${IUSE//+} && use c++0x; then
224 ewarn "You are about to build Qt4 using the C++11 standard. Even though"
225 ewarn "this is an official standard, some of the reverse dependencies"
226 ewarn "may fail to compile or link againt the Qt4 libraries. Before"
227 ewarn "reporting a bug, make sure your bug is reproducible with c++0x"
228 ewarn "disabled."
229 append-flags -std=c++0x 178 append-cxxflags -std=c++0x
230 fi
231 # Unsupported old gcc versions - hardened needs this :(
232 if [[ $(gcc-major-version) -lt 4 ]] ; then
233 ewarn "Appending -fno-stack-protector to CXXFLAGS"
234 append-cxxflags -fno-stack-protector
235 # Bug 253127
236 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \
237 -i "${S}"/mkspecs/common/g++.conf || die "sed ${S}/mkspecs/common/g++.conf failed"
238 fi 179 fi
239 180
240 # Bug 261632 181 # Bug 261632
241 if use ppc64; then 182 if use ppc64; then
242 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS"
243 append-flags -mminimal-toc 183 append-flags -mminimal-toc
244 fi 184 fi
245 185
246 # Bug 282984 && Bug 295530 186 # Bug 373061
247 sed -e "s:\(^SYSTEM_VARIABLES\):CC=\"$(tc-getCC)\"\nCXX=\"$(tc-getCXX)\"\nCFLAGS=\"${CFLAGS}\"\nCXXFLAGS=\"${CXXFLAGS}\"\nLDFLAGS=\"${LDFLAGS}\"\n\1:" \ 187 # qmake bus errors with -O2 or -O3 but -O1 works
248 -i configure || die "sed qmake compilers failed" 188 if [[ ${CHOST} == *86*-apple-darwin* ]]; then
249 # bug 321335 189 replace-flags -O[23] -O1
250 if version_is_at_least 4.6; then
251 find ./config.tests/unix -name "*.test" -type f -exec grep -lZ \$MAKE '{}' \; | \
252 xargs -0 \
253 sed -e "s:\(\$MAKE\):\1 CC=\"$(tc-getCC)\" CXX=\"$(tc-getCXX)\" LD=\"$(tc-getCXX)\" LINK=\"$(tc-getCXX)\":g" \
254 -i || die "sed test compilers failed"
255 fi 190 fi
191
192 # Bug 417105
193 # graphite on gcc 4.7 causes miscompilations
194 if [[ $(gcc-version) == "4.7" ]]; then
195 filter-flags -fgraphite-identity
196 fi
197
198 # Respect CC, CXX, {C,CXX,LD}FLAGS in .qmake.cache
199 sed -e "/^SYSTEM_VARIABLES=/i \
200 CC='$(tc-getCC)'\n\
201 CXX='$(tc-getCXX)'\n\
202 CFLAGS='${CFLAGS}'\n\
203 CXXFLAGS='${CXXFLAGS}'\n\
204 LDFLAGS='${LDFLAGS}'\n\
205 QMakeVar set QMAKE_CFLAGS_RELEASE\n\
206 QMakeVar set QMAKE_CFLAGS_DEBUG\n\
207 QMakeVar set QMAKE_CXXFLAGS_RELEASE\n\
208 QMakeVar set QMAKE_CXXFLAGS_DEBUG\n\
209 QMakeVar set QMAKE_LFLAGS_RELEASE\n\
210 QMakeVar set QMAKE_LFLAGS_DEBUG\n"\
211 -i configure \
212 || die "sed SYSTEM_VARIABLES failed"
213
214 # Respect CC, CXX, LINK and *FLAGS in config.tests
215 find config.tests/unix -name '*.test' -type f -print0 | xargs -0 \
216 sed -i -e "/bin\/qmake/ s: \"\$SRCDIR/: \
217 'QMAKE_CC=$(tc-getCC)' 'QMAKE_CXX=$(tc-getCXX)' 'QMAKE_LINK=$(tc-getCXX)' \
218 'QMAKE_CFLAGS+=${CFLAGS}' 'QMAKE_CXXFLAGS+=${CXXFLAGS}' 'QMAKE_LFLAGS+=${LDFLAGS}'&:" \
219 || die "sed config.tests failed"
256 220
257 # Bug 172219 221 # Bug 172219
258 sed -e "s:X11R6/::" \ 222 sed -e 's:/X11R6/:/:' -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
259 -i "${S}"/mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed ${S}/mkspecs/$(qt_mkspecs_dir)/qmake.conf failed"
260 223
261 if [[ ${CHOST} == *-darwin* ]]; then 224 if [[ ${CHOST} == *-darwin* ]]; then
262 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib 225 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib
263 # crippled (by design) :/ 226 # crippled (by design) :/
227 local mac_gpp_conf=
228 if [[ -f mkspecs/common/mac-g++.conf ]]; then
229 # qt < 4.8 has mac-g++.conf
230 mac_gpp_conf="mkspecs/common/mac-g++.conf"
231 elif [[ -f mkspecs/common/g++-macx.conf ]]; then
232 # qt >= 4.8 has g++-macx.conf
233 mac_gpp_conf="mkspecs/common/g++-macx.conf"
234 else
235 die "no known conf file for mac found"
236 fi
237 sed \
264 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \ 238 -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \
265 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \ 239 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \
266 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \ 240 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \
267 -e "s:-arch\s\w*::g" \ 241 -e "s:-arch\s\w*::g" \
268 -i mkspecs/common/mac-g++.conf || die "sed mkspecs/common/mac-g++.conf failed" 242 -i ${mac_gpp_conf} \
243 || die "sed ${mac_gpp_conf} failed"
269 244
270 # Fix configure's -arch settings that appear in qmake/Makefile and also 245 # Fix configure's -arch settings that appear in qmake/Makefile and also
271 # fix arch handling (automagically duplicates our -arch arg and breaks 246 # fix arch handling (automagically duplicates our -arch arg and breaks
272 # pch). Additionally disable Xarch support. 247 # pch). Additionally disable Xarch support.
248 local mac_gcc_confs="${mac_gpp_conf}"
249 if [[ -f mkspecs/common/gcc-base-macx.conf ]]; then
250 mac_gcc_confs+=" mkspecs/common/gcc-base-macx.conf"
251 fi
273 sed \ 252 sed \
274 -e "s:-arch i386::" \ 253 -e "s:-arch i386::" \
275 -e "s:-arch ppc::" \ 254 -e "s:-arch ppc::" \
276 -e "s:-arch x86_64::" \ 255 -e "s:-arch x86_64::" \
277 -e "s:-arch ppc64::" \ 256 -e "s:-arch ppc64::" \
278 -e "s:-arch \$i::" \ 257 -e "s:-arch \$i::" \
279 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \ 258 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \
280 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \ 259 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \
281 -e "s:-Xarch_x86_64::g" \ 260 -e "s:-Xarch_x86_64::g" \
282 -e "s:-Xarch_ppc64::g" \ 261 -e "s:-Xarch_ppc64::g" \
283 -i configure mkspecs/common/mac-g++.conf || die "sed configure failed" 262 -i configure ${mac_gcc_confs} \
263 || die "sed -arch/-Xarch failed"
284 264
285 # On Snow Leopard don't fall back to 10.5 deployment target. 265 # On Snow Leopard don't fall back to 10.5 deployment target.
286 if [[ ${CHOST} == *-apple-darwin10 ]] ; then 266 if [[ ${CHOST} == *-apple-darwin10 ]]; then
287 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \ 267 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \
288 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \ 268 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \
289 -i configure mkspecs/common/mac-g++.conf || die "sed configure failed" 269 -i configure ${mac_gpp_conf} \
270 || die "sed deployment target failed"
290 fi 271 fi
291 fi 272 fi
292 273
293 # this one is needed for all systems with a separate -liconv, apart from 274 # this one is needed for all systems with a separate -liconv, apart from
294 # Darwin, for which the sources already cater for -liconv 275 # Darwin, for which the sources already cater for -liconv
295 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]] ; then 276 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
296 sed \ 277 sed -e 's|mac:\(LIBS += -liconv\)|\1|g' \
297 -e "s|mac:LIBS += -liconv|LIBS += -liconv|g" \
298 -i config.tests/unix/iconv/iconv.pro \ 278 -i config.tests/unix/iconv/iconv.pro \
299 || die "sed on iconv.pro failed" 279 || die "sed iconv.pro failed"
300 fi 280 fi
301 281
302 # we need some patches for Solaris 282 # we need some patches for Solaris
303 sed -i \
304 -e '/^QMAKE_LFLAGS_THREAD/a\QMAKE_LFLAGS_DYNAMIC_LIST = -Wl,--dynamic-list,' \ 283 sed -i -e '/^QMAKE_LFLAGS_THREAD/a\QMAKE_LFLAGS_DYNAMIC_LIST = -Wl,--dynamic-list,' \
305 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die 284 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
306 # use GCC over SunStudio 285 # use GCC over SunStudio
307 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die 286 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die
308 # don't flirt with non-Prefix stuff, we're quite possessive 287 # do not flirt with non-Prefix stuff, we're quite possessive
309 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \ 288 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \
310 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die 289 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
311 # strip predefined CFLAGS from qmake ( bug #312689 )
312 sed -i '/^QMAKE_CFLAGS_RELEASE/s:+=.*:+=:' mkspecs/common/g++.conf
313 290
314 base_src_prepare 291 # apply patches
292 [[ -n ${PATCHES[@]} ]] && epatch "${PATCHES[@]}"
293 epatch_user
315} 294}
316 295
317# @FUNCTION: qt4-build_src_configure 296# @FUNCTION: qt4-build_src_configure
318# @DESCRIPTION: 297# @DESCRIPTION:
319# Default configure phase 298# Default configure phase
320qt4-build_src_configure() { 299qt4-build_src_configure() {
321 setqtenv 300 setqtenv
322 myconf="$(standard_configure_options) ${myconf}" 301
302 local conf="
303 -prefix ${QTPREFIXDIR}
304 -bindir ${QTBINDIR}
305 -libdir ${QTLIBDIR}
306 -docdir ${QTDOCDIR}
307 -headerdir ${QTHEADERDIR}
308 -plugindir ${QTPLUGINDIR}
309 -importdir ${QTIMPORTDIR}
310 -datadir ${QTDATADIR}
311 -translationdir ${QTTRANSDIR}
312 -sysconfdir ${QTSYSCONFDIR}
313 -examplesdir ${QTEXAMPLESDIR}
314 -demosdir ${QTDEMOSDIR}
315 -opensource -confirm-license
316 -shared -fast -largefile -stl -verbose
317 -nomake examples -nomake demos"
318
319 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
320 # $(tc-arch). Therefore we convert it to supported values.
321 case "$(tc-arch)" in
322 amd64|x64-*) conf+=" -arch x86_64" ;;
323 ppc-macos) conf+=" -arch ppc" ;;
324 ppc|ppc64|ppc-*) conf+=" -arch powerpc" ;;
325 sparc|sparc-*|sparc64-*) conf+=" -arch sparc" ;;
326 x86-macos) conf+=" -arch x86" ;;
327 x86|x86-*) conf+=" -arch i386" ;;
328 alpha|arm|arm64|ia64|mips|s390) conf+=" -arch $(tc-arch)" ;;
329 hppa|sh) conf+=" -arch generic" ;;
330 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
331 esac
332
333 conf+=" -platform $(qt_mkspecs_dir)"
334
335 [[ $(get_libdir) != lib ]] && conf+=" -L${EPREFIX}/usr/$(get_libdir)"
336
337 # debug/release
338 if use debug; then
339 conf+=" -debug"
340 else
341 conf+=" -release"
342 fi
343 conf+=" -no-separate-debug-info"
344
345 # exceptions USE flag
346 conf+=" $(in_iuse exceptions && qt_use exceptions || echo -exceptions)"
347
348 # disable rpath (bug 380415), except on prefix (bug 417169)
349 use prefix || conf+=" -no-rpath"
350
351 # precompiled headers don't work on hardened, where the flag is masked
352 conf+=" $(qt_use pch)"
353
354 # -reduce-relocations
355 # This flag seems to introduce major breakage to applications,
356 # mostly to be seen as a core dump with the message "QPixmap: Must
357 # construct a QApplication before a QPaintDevice" on Solaris.
358 # -- Daniel Vergien
359 [[ ${CHOST} != *-solaris* ]] && conf+=" -reduce-relocations"
323 360
324 # this one is needed for all systems with a separate -liconv, apart from 361 # this one is needed for all systems with a separate -liconv, apart from
325 # Darwin, for which the sources already cater for -liconv 362 # Darwin, for which the sources already cater for -liconv
326 use !elibc_glibc && [[ ${CHOST} != *-darwin* ]] && \ 363 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
327 myconf+=" -liconv" 364 conf+=" -liconv"
365 fi
328 366
329 if has glib ${IUSE//+} && use glib; then 367 if use_if_iuse glib; then
330 # use -I, -L and -l from configure
331 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)" 368 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)"
332 # avoid the -pthread argument 369 # avoid the -pthread argument
333 myconf+=" ${glibflags//-pthread}" 370 conf+=" ${glibflags//-pthread}"
334 unset glibflags 371 unset glibflags
335 fi 372 fi
336 373
337 if has qpa ${IUSE//+} && use qpa; then
338 ewarn
339 ewarn "The qpa useflag enables the Qt Platform Abstraction, formely"
340 ewarn "known as Qt Lighthouse. If you are not sure what that is, then"
341 ewarn "disable it before reporting any bugs related to this useflag."
342 ewarn
343 myconf+=" -qpa"
344 fi
345
346 if use aqua ; then 374 if use aqua; then
347 # On (snow) leopard use the new (frameworked) cocoa code. 375 # On (snow) leopard use the new (frameworked) cocoa code.
348 if [[ ${CHOST##*-darwin} -ge 9 ]] ; then 376 if [[ ${CHOST##*-darwin} -ge 9 ]]; then
349 myconf+=" -cocoa -framework" 377 conf+=" -cocoa -framework"
378 # We need the source's headers, not the installed ones.
379 conf+=" -I${S}/include"
380 # Add hint for the framework location.
381 conf+=" -F${QTLIBDIR}"
350 382
351 # We are crazy and build cocoa + qt3support :-) 383 # We are crazy and build cocoa + qt3support :-)
352 if use qt3support; then 384 if use qt3support; then
353 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \ 385 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \
354 -i configure 386 -i configure || die
355 fi 387 fi
356 388 else
357 # We need the source's headers, not the installed ones. 389 conf+=" -no-framework"
358 myconf+=" -I${S}/include"
359
360 # Add hint for the framework location.
361 myconf+=" -F${QTLIBDIR}"
362 fi 390 fi
363 else 391 else
364 # freetype2 include dir is non-standard, thus include it on configure 392 # freetype2 include dir is non-standard, thus pass it to configure
365 # use -I from configure
366 myconf+=" $(pkg-config --cflags freetype2)" 393 conf+=" $(pkg-config --cflags-only-I freetype2)"
367 fi 394 fi
368 395
369 # Disable SSE4.x, since auto-detection is currently broken 396 conf+=" ${myconf}"
370 # Upstream bug http://bugreports.qt.nokia.com/browse/QTBUG-13623 397 myconf=
371 [[ ${PV} == "4.7.1" ]] && myconf+=" -no-sse4.1 -no-sse4.2"
372 398
373 echo ./configure ${myconf} 399 echo ./configure ${conf}
374 ./configure ${myconf} || die "./configure failed" 400 ./configure ${conf} || die "./configure failed"
375 myconf=""
376 401
377 prepare_directories ${QT4_TARGET_DIRECTORIES} 402 prepare_directories ${QT4_TARGET_DIRECTORIES}
378} 403}
379 404
380# @FUNCTION: qt4-build_src_compile 405# @FUNCTION: qt4-build_src_compile
388 413
389# @FUNCTION: qt4-build_src_test 414# @FUNCTION: qt4-build_src_test
390# @DESCRIPTION: 415# @DESCRIPTION:
391# Runs tests only in target directories. 416# Runs tests only in target directories.
392qt4-build_src_test() { 417qt4-build_src_test() {
418 # QtMultimedia does not have any test suite (bug #332299)
419 [[ ${CATEGORY}/${PN} == dev-qt/qtmultimedia ]] && return
420
393 for dir in ${QT4_TARGET_DIRECTORIES}; do 421 for dir in ${QT4_TARGET_DIRECTORIES}; do
394 emake -j1 check -C ${dir} 422 emake -j1 check -C ${dir}
395 done 423 done
396} 424}
397 425
398# @FUNCTION: fix_includes 426# @FUNCTION: fix_includes
399# @DESCRIPTION: 427# @DESCRIPTION:
400# For MacOSX we need to add some symlinks when frameworks are 428# For MacOS X we need to add some symlinks when frameworks are
401# being used, to avoid complications with some more or less stupid packages. 429# being used, to avoid complications with some more or less stupid packages.
402fix_includes() { 430fix_includes() {
403 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]] ; then 431 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]]; then
432 local frw dest f h rdir
404 # Some packages tend to include <Qt/...> 433 # Some packages tend to include <Qt/...>
405 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt 434 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt
406 435
407 # Fake normal headers when frameworks are installed... eases life later on 436 # Fake normal headers when frameworks are installed... eases life later
408 local dest f 437 # on, make sure we use relative links though, as some ebuilds assume
438 # these dirs exist in src_install to add additional files
439 f=${QTHEADERDIR}
440 h=${QTLIBDIR}
441 while [[ -n ${f} && ${f%%/*} == ${h%%/*} ]] ; do
442 f=${f#*/}
443 h=${h#*/}
444 done
445 rdir=${h}
446 f="../"
447 while [[ ${h} == */* ]] ; do
448 f="${f}../"
449 h=${h#*/}
450 done
451 rdir="${f}${rdir}"
452
409 for frw in "${D}${QTLIBDIR}"/*.framework; do 453 for frw in "${D}${QTLIBDIR}"/*.framework; do
410 [[ -e "${frw}"/Headers ]] || continue 454 [[ -e "${frw}"/Headers ]] || continue
411 f=$(basename ${frw}) 455 f=$(basename ${frw})
412 dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework} 456 dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework}
413 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers "${dest}" 457 dosym "${rdir}"/${f}/Headers "${dest}"
414 458
415 # Link normal headers as well. 459 # Link normal headers as well.
416 for hdr in "${D}/${QTLIBDIR}/${f}"/Headers/*; do 460 for hdr in "${D}/${QTLIBDIR}/${f}"/Headers/*; do
417 h=$(basename ${hdr}) 461 h=$(basename ${hdr})
418 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers/${h} "${QTHEADERDIR#${EPREFIX}}"/Qt/${h} 462 dosym "../${rdir}"/${f}/Headers/${h} \
463 "${QTHEADERDIR#${EPREFIX}}"/Qt/${h}
419 done 464 done
420 done 465 done
421 fi 466 fi
422} 467}
423 468
424# @FUNCTION: qt4-build_src_install 469# @FUNCTION: qt4-build_src_install
425# @DESCRIPTION: 470# @DESCRIPTION:
426# Perform the actual installation including some library fixes. 471# Perform the actual installation including some library fixes.
427qt4-build_src_install() { 472qt4-build_src_install() {
428 [[ ${EAPI} == 2 ]] && use !prefix && ED=${D}
429 setqtenv 473 setqtenv
474
430 install_directories ${QT4_TARGET_DIRECTORIES} 475 install_directories ${QT4_TARGET_DIRECTORIES}
431 install_qconfigs 476 install_qconfigs
432 fix_library_files 477 fix_library_files
433 fix_includes 478 fix_includes
479
434 # remove .la files since we are building only shared Qt libraries 480 # remove .la files since we are building only shared libraries
435 find "${D}"${QTLIBDIR} -name "*.la" -print0 | xargs -0 rm 481 prune_libtool_files
436} 482}
437 483
438# @FUNCTION: setqtenv 484# @FUNCTION: setqtenv
485# @INTERNAL
439setqtenv() { 486setqtenv() {
440 # Set up installation directories 487 # Set up installation directories
441 QTBASEDIR=${EPREFIX}/usr/$(get_libdir)/qt4
442 QTPREFIXDIR=${EPREFIX}/usr 488 QTPREFIXDIR=${EPREFIX}/usr
443 QTBINDIR=${EPREFIX}/usr/bin 489 QTBINDIR=${QTPREFIXDIR}/bin
444 QTLIBDIR=${EPREFIX}/usr/$(get_libdir)/qt4 490 QTLIBDIR=${QTPREFIXDIR}/$(get_libdir)/qt4
445 QMAKE_LIBDIR_QT=${QTLIBDIR}
446 QTPCDIR=${EPREFIX}/usr/$(get_libdir)/pkgconfig 491 QTPCDIR=${QTPREFIXDIR}/$(get_libdir)/pkgconfig
447 QTDATADIR=${EPREFIX}/usr/share/qt4
448 QTDOCDIR=${EPREFIX}/usr/share/doc/qt-${PV} 492 QTDOCDIR=${QTPREFIXDIR}/share/doc/qt-${PV}
449 QTHEADERDIR=${EPREFIX}/usr/include/qt4 493 QTHEADERDIR=${QTPREFIXDIR}/include/qt4
450 QTPLUGINDIR=${QTLIBDIR}/plugins 494 QTPLUGINDIR=${QTLIBDIR}/plugins
495 QTIMPORTDIR=${QTLIBDIR}/imports
496 QTDATADIR=${QTPREFIXDIR}/share/qt4
497 QTTRANSDIR=${QTDATADIR}/translations
451 QTSYSCONFDIR=${EPREFIX}/etc/qt4 498 QTSYSCONFDIR=${EPREFIX}/etc/qt4
452 QTTRANSDIR=${QTDATADIR}/translations
453 QTEXAMPLESDIR=${QTDATADIR}/examples 499 QTEXAMPLESDIR=${QTDATADIR}/examples
454 QTDEMOSDIR=${QTDATADIR}/demos 500 QTDEMOSDIR=${QTDATADIR}/demos
455 QT_INSTALL_PREFIX=${EPREFIX}/usr/$(get_libdir)/qt4 501 QMAKE_LIBDIR_QT=${QTLIBDIR}
502
456 PLATFORM=$(qt_mkspecs_dir) 503 PLATFORM=$(qt_mkspecs_dir)
457
458 unset QMAKESPEC 504 unset QMAKESPEC
459}
460 505
461# @FUNCTION: standard_configure_options 506 export XDG_CONFIG_HOME="${T}"
462# @DESCRIPTION:
463# Sets up some standard configure options, like libdir (if necessary), whether
464# debug info is wanted or not.
465standard_configure_options() {
466 local myconf=
467
468 [[ $(get_libdir) != lib ]] && myconf+=" -L${EPREFIX}/usr/$(get_libdir)"
469
470 # Disable visibility explicitly if gcc version isn't 4
471 if [[ $(gcc-major-version) -lt 4 ]]; then
472 myconf+=" -no-reduce-exports"
473 fi
474
475 # precompiled headers doesn't work on hardened, where the flag is masked.
476 myconf+=" $(qt_use pch)"
477
478 if use debug; then
479 myconf+=" -debug"
480 else
481 myconf+=" -release"
482 fi
483 myconf+=" -no-separate-debug-info"
484
485 use aqua && myconf+=" -no-framework"
486
487 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
488 # $(tc-arch). Therefore we convert it to supported values.
489 case "$(tc-arch)" in
490 amd64|x64-*) myconf+=" -arch x86_64" ;;
491 ppc-macos) myconf+=" -arch ppc" ;;
492 ppc|ppc64|ppc-*) myconf+=" -arch powerpc" ;;
493 sparc|sparc-*) myconf+=" -arch sparc" ;;
494 x86-macos) myconf+=" -arch x86" ;;
495 x86|x86-*) myconf+=" -arch i386" ;;
496 alpha|arm|ia64|mips|s390|sparc) myconf+=" -arch $(tc-arch)" ;;
497 hppa|sh) myconf+=" -arch generic" ;;
498 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
499 esac
500
501 # 4.5: build everything but qt-xmlpatterns w/o exceptions
502 # 4.6: exceptions USE flag
503 local exceptions="-exceptions"
504 case "${PV}" in
505 4.5.*)
506 [[ ${PN} == "qt-xmlpatterns" ]] || exceptions="-no-exceptions"
507 ;;
508 *)
509 has exceptions "${IUSE//+}" && exceptions="$(qt_use exceptions)"
510 ;;
511 esac
512
513 # note about -reduce-relocations:
514 # That flag seems to introduce major breakage to applications,
515 # mostly to be seen as a core dump with the message "QPixmap: Must
516 # construct a QApplication before a QPaintDevice" on Solaris
517 # -- Daniel Vergien
518 [[ ${CHOST} != *-solaris* ]] && myconf+=" -reduce-relocations"
519
520 myconf+=" -platform $(qt_mkspecs_dir) -stl -verbose -largefile -confirm-license
521 -prefix ${QTPREFIXDIR} -bindir ${QTBINDIR} -libdir ${QTLIBDIR}
522 -datadir ${QTDATADIR} -docdir ${QTDOCDIR} -headerdir ${QTHEADERDIR}
523 -plugindir ${QTPLUGINDIR} -sysconfdir ${QTSYSCONFDIR}
524 -translationdir ${QTTRANSDIR} -examplesdir ${QTEXAMPLESDIR}
525 -demosdir ${QTDEMOSDIR} -silent -fast -opensource
526 ${exceptions}
527 -nomake examples -nomake demos"
528
529 echo "${myconf}"
530} 507}
531 508
532# @FUNCTION: prepare_directories 509# @FUNCTION: prepare_directories
533# @USAGE: < directories > 510# @USAGE: < directories >
511# @INTERNAL
534# @DESCRIPTION: 512# @DESCRIPTION:
535# Generates makefiles for the directories set in $QT4_TARGET_DIRECTORIES 513# Generates Makefiles for the given list of directories.
536prepare_directories() { 514prepare_directories() {
537 for x in "$@"; do 515 for x in "$@"; do
538 pushd "${S}"/${x} >/dev/null 516 pushd "${S}"/${x} >/dev/null || die
539 einfo "running qmake in: $x" 517 einfo "Running qmake in: ${x}"
540 # avoid running over the maximum argument number, bug #299810 518 "${S}"/bin/qmake \
541 { 519 "LIBS+=-L${QTLIBDIR}" \
542 echo "${S}"/mkspecs/common/*.conf 520 "CONFIG+=nostrip" \
543 find "${S}" -name '*.pr[io]' 521 || die "qmake failed"
544 } | xargs sed -i -e "s:\$\$\[QT_INSTALL_LIBS\]:${EPREFIX}/usr/$(get_libdir)/qt4:g" || die
545 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed"
546 popd >/dev/null 522 popd >/dev/null || die
547 done 523 done
548} 524}
549
550 525
551# @FUNCTION: build_directories 526# @FUNCTION: build_directories
552# @USAGE: < directories > 527# @USAGE: < directories >
528# @INTERNAL
553# @DESCRIPTION: 529# @DESCRIPTION:
554# Compiles the code in $QT4_TARGET_DIRECTORIES 530# Compiles the code in the given list of directories.
555build_directories() { 531build_directories() {
556 for x in "$@"; do 532 for x in "$@"; do
557 pushd "${S}"/${x} >/dev/null 533 pushd "${S}"/${x} >/dev/null || die
534 emake \
535 AR="$(tc-getAR) cqs" \
558 emake CC="$(tc-getCC)" \ 536 CC="$(tc-getCC)" \
559 CXX="$(tc-getCXX)" \ 537 CXX="$(tc-getCXX)" \
560 LINK="$(tc-getCXX)" || die "emake failed" 538 LINK="$(tc-getCXX)" \
539 RANLIB=":" \
540 STRIP=":"
561 popd >/dev/null 541 popd >/dev/null || die
562 done 542 done
563} 543}
564 544
565# @FUNCTION: install_directories 545# @FUNCTION: install_directories
566# @USAGE: < directories > 546# @USAGE: < directories >
547# @INTERNAL
567# @DESCRIPTION: 548# @DESCRIPTION:
568# run emake install in the given directories, which are separated by spaces 549# Runs emake install in the given directories, which are separated by spaces.
569install_directories() { 550install_directories() {
570 for x in "$@"; do 551 for x in "$@"; do
571 pushd "${S}"/${x} >/dev/null || die "Can't pushd ${S}/${x}" 552 pushd "${S}"/${x} >/dev/null || die
572 emake INSTALL_ROOT="${D}" install || die "emake install failed" 553 emake INSTALL_ROOT="${D}" install
573 popd >/dev/null || die "Can't popd from ${S}/${x}" 554 popd >/dev/null || die
574 done 555 done
575} 556}
576 557
577# @ECLASS-VARIABLE: QCONFIG_ADD 558# @ECLASS-VARIABLE: QCONFIG_ADD
578# @DESCRIPTION: 559# @DESCRIPTION:
588# @DESCRIPTION: 569# @DESCRIPTION:
589# List variables that should be defined at the top of QtCore/qconfig.h 570# List variables that should be defined at the top of QtCore/qconfig.h
590: ${QCONFIG_DEFINE:=} 571: ${QCONFIG_DEFINE:=}
591 572
592# @FUNCTION: install_qconfigs 573# @FUNCTION: install_qconfigs
574# @INTERNAL
593# @DESCRIPTION: 575# @DESCRIPTION:
594# Install gentoo-specific mkspecs configurations 576# Install gentoo-specific mkspecs configurations.
595install_qconfigs() { 577install_qconfigs() {
596 local x 578 local x
597 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then 579 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then
598 for x in QCONFIG_ADD QCONFIG_REMOVE; do 580 for x in QCONFIG_ADD QCONFIG_REMOVE; do
599 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri 581 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri
600 done 582 done
601 insinto ${QTDATADIR#${EPREFIX}}/mkspecs/gentoo 583 insinto ${QTDATADIR#${EPREFIX}}/mkspecs/gentoo
602 doins "${T}"/${PN}-qconfig.pri || die "installing ${PN}-qconfig.pri failed" 584 doins "${T}"/${PN}-qconfig.pri
603 fi 585 fi
604 586
605 if [[ -n ${QCONFIG_DEFINE} ]]; then 587 if [[ -n ${QCONFIG_DEFINE} ]]; then
606 for x in ${QCONFIG_DEFINE}; do 588 for x in ${QCONFIG_DEFINE}; do
607 echo "#define ${x}" >> "${T}"/gentoo-${PN}-qconfig.h 589 echo "#define ${x}" >> "${T}"/gentoo-${PN}-qconfig.h
608 done 590 done
609 insinto ${QTHEADERDIR#${EPREFIX}}/Gentoo 591 insinto ${QTHEADERDIR#${EPREFIX}}/Gentoo
610 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed" 592 doins "${T}"/gentoo-${PN}-qconfig.h
611 fi 593 fi
612} 594}
613 595
614# @FUNCTION: generate_qconfigs 596# @FUNCTION: generate_qconfigs
597# @INTERNAL
615# @DESCRIPTION: 598# @DESCRIPTION:
616# Generates gentoo-specific configurations 599# Generates gentoo-specific qconfig.{h,pri}.
617generate_qconfigs() { 600generate_qconfigs() {
618 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == x11-libs/qt-core ]]; then 601 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == dev-qt/qtcore ]]; then
619 local x qconfig_add qconfig_remove qconfig_new 602 local x qconfig_add qconfig_remove qconfig_new
620 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do 603 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do
621 [[ -f ${x} ]] || continue 604 [[ -f ${x} ]] || continue
622 qconfig_add+=" $(sed -n 's/^QCONFIG_ADD=//p' "${x}")" 605 qconfig_add+=" $(sed -n 's/^QCONFIG_ADD=//p' "${x}")"
623 qconfig_remove+=" $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")" 606 qconfig_remove+=" $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")"
624 done 607 done
625 608
626 # these error checks do not use die because dying in pkg_post{inst,rm} 609 # these error checks do not use die because dying in pkg_post{inst,rm}
627 # just makes things worse. 610 # just makes things worse.
628 if [[ -e "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri ]]; then 611 if [[ -e "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri ]]; then
629 # start with the qconfig.pri that qt-core installed 612 # start with the qconfig.pri that qtcore installed
630 if ! cp "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri \ 613 if ! cp "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri \
631 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then 614 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then
632 eerror "cp qconfig failed." 615 eerror "cp qconfig failed."
633 return 1 616 return 1
634 fi 617 fi
670 fi 653 fi
671} 654}
672 655
673# @FUNCTION: qt4-build_pkg_postrm 656# @FUNCTION: qt4-build_pkg_postrm
674# @DESCRIPTION: 657# @DESCRIPTION:
675# Generate configurations when the package is completely removed 658# Regenerate configuration when the package is completely removed.
676qt4-build_pkg_postrm() { 659qt4-build_pkg_postrm() {
677 generate_qconfigs 660 generate_qconfigs
678} 661}
679 662
680# @FUNCTION: qt4-build_pkg_postinst 663# @FUNCTION: qt4-build_pkg_postinst
681# @DESCRIPTION: 664# @DESCRIPTION:
682# Generate configuration, plus throws a message about possible 665# Regenerate configuration, plus throw a message about possible
683# breakages and proposed solutions. 666# breakages and proposed solutions.
684qt4-build_pkg_postinst() { 667qt4-build_pkg_postinst() {
685 generate_qconfigs 668 generate_qconfigs
686} 669}
687 670
688# @FUNCTION: skip_qmake_build_patch 671# @FUNCTION: skip_qmake_build
672# @INTERNAL
689# @DESCRIPTION: 673# @DESCRIPTION:
690# Don't need to build qmake, as it's already installed from qt-core 674# Patches configure to skip qmake compilation, as it's already installed by qtcore.
691skip_qmake_build_patch() { 675skip_qmake_build() {
692 # Don't need to build qmake, as it's already installed from qt-core
693 sed -i -e "s:if true:if false:g" "${S}"/configure || die "Sed failed" 676 sed -i -e "s:if true:if false:g" "${S}"/configure || die
694} 677}
695 678
696# @FUNCTION: skip_project_generation_patch 679# @FUNCTION: skip_project_generation
680# @INTERNAL
697# @DESCRIPTION: 681# @DESCRIPTION:
698# Exit the script early by throwing in an exit before all of the .pro files are scanned 682# Exit the script early by throwing in an exit before all of the .pro files are scanned.
699skip_project_generation_patch() { 683skip_project_generation() {
700 # Exit the script early by throwing in an exit before all of the .pro files are scanned
701 sed -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" \ 684 sed -i -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" "${S}"/configure || die
702 -i "${S}"/configure || die "Sed failed"
703} 685}
704 686
705# @FUNCTION: symlink_binaries_to_buildtree 687# @FUNCTION: symlink_binaries_to_buildtree
688# @INTERNAL
706# @DESCRIPTION: 689# @DESCRIPTION:
707# Symlink generated binaries to buildtree so they can be used during compilation 690# Symlinks generated binaries to buildtree, so they can be used during compilation time.
708# time
709symlink_binaries_to_buildtree() { 691symlink_binaries_to_buildtree() {
710 for bin in qmake moc uic rcc; do 692 for bin in qmake moc uic rcc; do
711 ln -s ${QTBINDIR}/${bin} "${S}"/bin/ || die "Symlinking ${bin} to ${S}/bin failed." 693 ln -s "${QTBINDIR}"/${bin} "${S}"/bin/ || die "symlinking ${bin} to ${S}/bin failed"
712 done 694 done
713} 695}
714 696
715# @FUNCTION: fix_library_files 697# @FUNCTION: fix_library_files
698# @INTERNAL
716# @DESCRIPTION: 699# @DESCRIPTION:
717# Fixes the pathes in *.la, *.prl, *.pc, as they are wrong due to sandbox and 700# Fixes the paths in *.la, *.prl, *.pc, as they are wrong due to sandbox and
718# moves the *.pc-files into the pkgconfig directory 701# moves the *.pc files into the pkgconfig directory.
719fix_library_files() { 702fix_library_files() {
703 local libfile
720 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do 704 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do
721 if [[ -e ${libfile} ]]; then 705 if [[ -e ${libfile} ]]; then
722 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "Sed on ${libfile} failed." 706 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "sed on ${libfile} failed"
723 fi 707 fi
724 done 708 done
725 709
726 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations. Fix: 710 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations
727 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do 711 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do
728 if [[ -e ${libfile} ]]; then 712 if [[ -e ${libfile} ]]; then
729 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "Sed failed" 713 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "sed on ${libfile} failed"
730 714
731 # Move .pc files into the pkgconfig directory 715 # Move .pc files into the pkgconfig directory
732 dodir ${QTPCDIR#${EPREFIX}} 716 dodir ${QTPCDIR#${EPREFIX}}
733 mv ${libfile} "${D}"/${QTPCDIR}/ \ 717 mv ${libfile} "${D}"/${QTPCDIR}/ || die "moving ${libfile} to ${D}/${QTPCDIR}/ failed"
734 || die "Moving ${libfile} to ${D}/${QTPCDIR}/ failed."
735 fi 718 fi
736 done 719 done
737 720
738 # Don't install an empty directory 721 # Don't install an empty directory
739 rmdir "${D}"/${QTLIBDIR}/pkgconfig 722 rmdir "${D}"/${QTLIBDIR}/pkgconfig
740} 723}
741 724
742# @FUNCTION: qt_use 725# @FUNCTION: qt_use
743# @USAGE: < flag > [ feature ] [ enableval ] 726# @USAGE: < flag > [ feature ] [ enableval ]
744# @DESCRIPTION: 727# @DESCRIPTION:
745# This will echo "${enableval}-${feature}" if <flag> is enabled, or 728# This will echo "-${enableval}-${feature}" if <flag> is enabled, or
746# "-no-${feature} if the flag is disabled. If [feature] is not specified <flag> 729# "-no-${feature}" if it's disabled. If [feature] is not specified, <flag>
747# will be used for that. If [enableval] is not specified, it omits the 730# will be used for that. If [enableval] is not specified, it omits the
748# assignment-part 731# "-${enableval}" part.
749qt_use() { 732qt_use() {
750 local flag=$1 733 use "$1" && echo "${3:+-$3}-${2:-$1}" || echo "-no-${2:-$1}"
751 local feature=$1
752 local enableval=
753
754 [[ -n $2 ]] && feature=$2
755 [[ -n $3 ]] && enableval=-$3
756
757 if use ${flag}; then
758 echo "${enableval}-${feature}"
759 else
760 echo "-no-${feature}"
761 fi
762} 734}
763 735
764# @FUNCTION: qt_mkspecs_dir 736# @FUNCTION: qt_mkspecs_dir
765# @RETURN: the specs-directory w/o path 737# @RETURN: the specs-directory w/o path
766# @DESCRIPTION: 738# @DESCRIPTION:
767# Allows us to define which mkspecs dir we want to use. 739# Allows us to define which mkspecs dir we want to use.
768qt_mkspecs_dir() { 740qt_mkspecs_dir() {
769 # Allows us to define which mkspecs dir we want to use.
770 local spec 741 local spec=
771 742
772 case ${CHOST} in 743 case "${CHOST}" in
773 *-freebsd*|*-dragonfly*) 744 *-freebsd*|*-dragonfly*)
774 spec=freebsd ;; 745 spec=freebsd ;;
775 *-openbsd*) 746 *-openbsd*)
776 spec=openbsd ;; 747 spec=openbsd ;;
777 *-netbsd*) 748 *-netbsd*)
788 *-solaris*) 759 *-solaris*)
789 spec=solaris ;; 760 spec=solaris ;;
790 *-linux-*|*-linux) 761 *-linux-*|*-linux)
791 spec=linux ;; 762 spec=linux ;;
792 *) 763 *)
793 die "Unknown CHOST, no platform choosen." 764 die "${FUNCNAME}(): Unknown CHOST '${CHOST}'" ;;
794 esac 765 esac
795 766
796 CXX=$(tc-getCXX) 767 case "$(tc-getCXX)" in
797 if [[ ${CXX} == *g++* ]]; then 768 *g++*)
798 spec+=-g++ 769 spec+=-g++ ;;
799 elif [[ ${CXX} == *icpc* ]]; then 770 *icpc*)
800 spec+=-icc 771 spec+=-icc ;;
801 else 772 *)
802 die "Unknown compiler ${CXX}." 773 die "${FUNCNAME}(): Unknown compiler '$(tc-getCXX)'" ;;
803 fi 774 esac
804 if [[ -n ${LIBDIR/lib} ]]; then
805 spec+=-${LIBDIR/lib}
806 fi
807 775
808 # Add -64 for 64bit profiles 776 # Add -64 for 64bit profiles
809 if use x64-freebsd || 777 if use x64-freebsd ||
810 use amd64-linux || 778 use amd64-linux ||
811 use x64-macos || 779 use x64-macos ||
816 fi 784 fi
817 785
818 echo "${spec}" 786 echo "${spec}"
819} 787}
820 788
821# @FUNCTION: qt_assistant_cleanup
822# @RETURN: nothing
823# @DESCRIPTION:
824# Tries to clean up tools.pro for qt-assistant ebuilds
825# Meant to be called in src_prepare
826qt_assistant_cleanup() {
827 # different versions (and branches...) may need different handling,
828 # add a case if you need special handling
829 case "${MY_PV_EXTRA}" in
830 *kde-qt*)
831 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \
832 -e "/mac/,/^embedded.*makeqpf$/d" \
833 -i tools/tools.pro || die "patching tools.pro failed"
834 ;;
835 *)
836 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \
837 -e "/mac/,/^embedded.*makeqpf$/d" \
838 -e "s/^\([ \t]*pixeltool\) /\1 qdoc3 /" \
839 -i tools/tools.pro || die "patching tools.pro failed"
840 ;;
841 esac
842}
843
844# @FUNCTION: qt_nolibx11 789# @FUNCTION: qt_nolibx11
845# @RETURN: nothing 790# @INTERNAL
846# @DESCRIPTION: 791# @DESCRIPTION:
847# Ignore X11 tests for packages that don't need X libraries installed 792# Skip X11 tests for packages that don't need X libraries installed.
848qt_nolibx11() { 793qt_nolibx11() {
849 einfo "removing X11 check to allow X-less compilation" 794 sed -i -e '/^if.*PLATFORM_X11.*CFG_GUI/,/^fi$/d' "${S}"/configure || die
850 sed -i "/unixtests\/compile.test.*config.tests\/x11\/xlib/,/fi$/d" "${S}"/configure ||
851 die "x11 check sed failed"
852} 795}
853 796
854EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install src_test pkg_postrm pkg_postinst 797EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install src_test pkg_postrm pkg_postinst

Legend:
Removed from v.1.96  
changed lines
  Added in v.1.159

  ViewVC Help
Powered by ViewVC 1.1.20